import es
import cPickle, datetime, os.path, psyco, random, threading, time
import cfglib, cmdlib, playerlib, popuplib

from configobj import ConfigObj
from time import sleep

T = threading.Thread
now = datetime.datetime.now()

psyco.full()
random.seed()

info = es.AddonInfo()
info.name = 'Attribute System'
info.version = 'RC 1'
info.url = ''
info.basename = 'mod_attributes'
info.author = 'CrAzD'
es.ServerVar('private_version', info.version, info.name).makepublic()


# Directory Setup
dirs = {}
dirs['base'] = str(es.ServerVar('eventscripts_addondir')).strip('\eventscripts').strip('addons')
dirs['cfg'] = dirs['base'] + 'cfg\\EventScripts\\'
dirs['db'] = dirs['cfg'] + 'DataBases\\Attributes\\'

for dir in dirs:
	if not os.path.exists(dirs[dir]):
		os.makedirs(dirs[dir])


# CFGs 
	# Attributes
cfgAttributes = cfglib.AddonCFG(dirs['cfg'] + 'Attributes.cfg')
attributes = {}

attributes['callWords'] =					cfgAttributes.cvar('callWords',	'!att, .att, !attributes, .attributes, /att, /attributes', 'Chat commands you want to use to call the attribute menu. | Seperate with a comman')

attributes['timeDeleteInactive'] =			cfgAttributes.cvar('timeDeleteInactive', 14, '0 = OFF | If this is 1 or greater then it automatically runs after every map. | How many days a player is inactive for before deletion.')

attributes['pointsPerLevel'] =				cfgAttributes.cvar('pointsPerLevel', 1, 'How many attribute points to give a player per level.')

attributes['maxLevel'] = 					cfgAttributes.cvar('maxLevel', 25, 'Max level a player can attain.')
attributes['maxPointsPerStat'] =			cfgAttributes.cvar('maxPointsPerStat', 25, 'The maximum amount of points you can put into a single stat.')

attributes['xpForDamageBonus'] =			cfgAttributes.cvar('xpForDamageBonus', 1.0, '0.0 = disabled | How much xp 1 point of bonus damage (Critical Damage/Damage from Power) is worth.')
attributes['xpForDamageBlocked'] =			cfgAttributes.cvar('xpForDamageBlocked', 1.5, '0.0 = disabled | How much xp 1 point of blocked damage is worth.')

attributes['worthPower'] =					cfgAttributes.cvar('worthPower', 5, 'This is a percentage value. \n//You gain additional damage so if you did 10 damage and you had 100% damage value you would deal 20 damage.')
attributes['worthPrecision'] =				cfgAttributes.cvar('worthPrecision', 3, 'This is a percentage value. \n//This will allow you critical hits, every critical hit will give you additional damage. Additional damage is: 1% to X%, X = level * criticalBonus')
attributes['criticalBonus'] =				cfgAttributes.cvar('criticalBonus', 10.0, '(Decimal Number) This is your maximum amount of bonus damage you can score per point. \n// This is a percentage amount, so if you hit for 8 and you have 10 points and each points is worth 10, you did a total of 16 damage.')
attributes['worthToughness'] =				cfgAttributes.cvar('worthToughness', 2.5, 'How much damage a point of toughness mitigates.')
attributes['minimumDamage'] =				cfgAttributes.cvar('minimumDamage', 1, 'This is the minimum amount of damage someone with toughness will take (stops people from becoming invisible).')
attributes['worthVitality'] =				cfgAttributes.cvar('worthVitality', 15, 'How much health a point of vitality will add.')

attributes['respec'] =						cfgAttributes.cvar('respec', 'ON', 'ON - OFF | This allows players to respec their attributes.')
attributes['respecCosts'] =					cfgAttributes.cvar('respecCost', 1, '0 = OFF | How many levels respecing costs.')
attributes['respecLimit'] =					cfgAttributes.cvar('respecLimit', 0, '0 = INFINITE | How many times a player can respec per map.')

cfgAttributes.write()
cfgAttributes.execute()

# Globals
tList = str(attributes['callWords'])
callWords = []
for word in tList.replace(', ', ',').split(','):
	callWords.append(word)

currentPlayers = {}
levelEXP = {}
popups = []
confirmation = []

def load():
	cmdlib.registerServerCommand('.deleteInactive', deleteInactive, 'Deletes all users who have been inactive for more than timeDeleteInactive.')
	buildLevelEXP()
	for user in es.getUseridList():
		es.server.mp_disable_autokick(user)
		T(target=loadDB, args=(playerlib.uniqueid(user, True),)).start()

def unload():
	cmdlib.unregisterServerCommand('.set')
	cmdlib.unregisterServerCommand('.all')
	cmdlib.unregisterServerCommand('.give')
	cmdlib.unregisterServerCommand('.deleteInactive')
	for user in es.getUseridList():
		steamid = playerlib.uniqueid(user, True)
		nFile = open(dirs['db'] + str(steamid).replace(':','-') + '.db', 'w')
		currentPlayers[steamid]['lastPlayed']['year'] = now.year
		currentPlayers[steamid]['lastPlayed']['month'] = now.month
		currentPlayers[steamid]['lastPlayed']['day'] = now.day
		cPickle.dump(currentPlayers[steamid], nFile)
		nFile.close()

def es_map_start(eV):
	global popups
	del popups
	popups = []
	if attributes['timeDeleteInactive'] > 0:
		deleteInactive()

def round_start(eV):
	buildLevelEXP()

def player_activate(eV):
	es.server.mp_disable_autokick(eV['userid'])
	T(target=loadDB, args=(playerlib.uniqueid(eV['userid'], True),)).start()

def player_disconnect(eV):
	global currentPlayers
	steamid = eV['es_steamid']
	if str(steamid).lower() == 'bot':
		steamid += '_' + str(eV['name']).upper()
	currentPlayers[steamid]['lastPlayed']['year'] = now.year
	currentPlayers[steamid]['lastPlayed']['month'] = now.month
	currentPlayers[steamid]['lastPlayed']['day'] = now.day
	nFile = open(dirs['db'] + str(steamid).replace(':','-') + '.db', 'w')
	cPickle.dump(currentPlayers[steamid], nFile)
	nFile.close()
	del currentPlayers[steamid]

def player_say(eV):
	T(target=threadPlayerSay, args=(eV['userid'], eV['es_steamid'], eV['text'],)).start()

def threadPlayerSay(user, steamid, text):
	if user in confirmation:
		if str(text).lower() == 'yes':
			popuplib.unsendname('respecConfirm_%s'%(user), user)
			respecPlayer(user, steamid)
			return
	if text[:4] == '.add':
		if currentPlayers[steamid]['unspentPoints'] <= 0:
			es.tell(user, 'You do not have any points to spend')
			return
		words = text.lower().split(' ')
		try:
			attribute = words[1]
			amount = int(words[2])
		except IndexError:
			es.tell(user, '#multi', '#defaultSyntax:  #green.add <Attribute> <Amount>\n#defaultExample:  #green.add power 8')
			return
		if amount > currentPlayers[steamid]['unspentPoints']:
			currentPlayers[steamid][attribute] += currentPlayers[steamid]['unspentPoints']
			currentPlayers[steamid]['unspentPoints'] = 0
			es.tell(user, '#multi', '#lightgreen%s #defaulthas been increased by #green%s#default!'%(attribute[:1].upper() + attribute[1:].lower(), currentPlayers[steamid]['unspentPoints']))
			return
		currentPlayers[steamid][attribute] += amount
		currentPlayers[steamid]['unspentPoints'] -= amount
		es.tell(user, '#multi', '#lightgreen%s #defaulthas been increased by #green%s#default!'%(attribute[:1].upper() + attribute[1:].lower(), currentPlayers[steamid]['unspentPoints']))
		if currentPlayers[steamid]['unspentPoints'] < 0:
			currentPlayers[steamid]['unspentPoints'] = 0
		return
	global popups
	for word in callWords:
		if text == word:
			if user in popups:
				es.tell(user, 'Close your current menu before requesting a new one.')
				return
			popups.append(user)
			menuCreate_Base(user, steamid)

def player_spawn(eV):
	if es.getplayerprop(eV['userid'], 'CBasePlayer.pl.deadflag') == 1:
		return
	global currentPlayers
	T(target=threadPlayerSpawn, args=(eV['userid'],)).start()

def threadPlayerSpawn(user):
	steamid = playerlib.uniqueid(user, True)
	try:
		es.setplayerprop(user, 'CBasePlayer.m_iHealth', int(100 + (currentPlayers[steamid]['vitality'] * attributes['worthVitality'])))
		currentPlayers[steamid]['gainedEXP'] = 0
		es.tell(user, '#multi', '#default#lightgreenExperience #defaultgained last round #green%s!'%(currentPlayers[steamid]['gainedEXP']))
	except KeyError:
		loadDB(steamid)
		threadPlayerSpawn(user)

def player_hurt(eV):
	T(target=threadPlayerHurt, args=(eV['userid'], eV['es_username'], eV['attacker'], eV['es_attackername'], eV['health'], eV['es_attackerhealth'], eV['dmg_health'], eV['weapon'], )).start()

def threadPlayerHurt(*args):
	global currentPlayers
	V, A = {}, {}
	V['id'] = int(args[0])
	A['id'] = int(args[2])
	A['steam'] = playerlib.uniqueid(A['id'], True)
	if es.getplayerprop(V['id'], 'CBasePlayer.pl.deadflag') == 1:
		currentPlayers[A['steam']]['currentEXP'] += int(args[6])
		T(target=scanNewLevel, args=(A['id'], A['steam'],)).start()
		return
	V['steam'] = playerlib.uniqueid(V['id'], True)
	V['name'] = args[1]
	V['health'] = int(args[4])
 	A['name'] = args[3]
	A['health'] = int(args[5])
	A['damage'] = int(args[6])
	A['weapon'] = args[7]
	es.setplayerprop(V['id'], 'CBasePlayer.m_iHealth', int(V['health'] + A['damage']))
	weaponDamage = float(A['damage'])
	bonusDamage = float(currentPlayers[A['steam']]['power'] * attributes['worthPower'])
	damage = weaponDamage + bonusDamage
	chance = int(round(currentPlayers[A['steam']]['precision'] * attributes['worthPrecision'], 0))
	if chance >= random.randrange(1, 100):
		es.tell(A['id'], '#multi', '#greenCRITCAL HIT on %s'%(V['name']))
		criticalBonus = float(currentPlayers[A['steam']]['level']) * float(attributes['criticalBonus'])
		damage *= criticalBonus
	blockedDamage = float(currentPlayers[V['steam']]['toughness'] * attributes['worthToughness'])
	nDamage = int(round(damage - blockedDamage, 0))
	if nDamage < 1:
		nDamage = 1
	if attributes['xpForDamageBlocked'] != 0.0:
		xp = blockedDamage * attributes['xpForDamageBlocked']
		currentPlayers[V['steam']]['gainedEXP'] += xp
		currentPlayers[V['steam']]['currentEXP'] += xp
	if attributes['xpForDamageBonus'] != 0.0:
		xp = nDamage * attributes['xpForDamageBonus']
		currentPlayers[A['steam']]['gainedEXP'] += xp
		currentPlayers[A['steam']]['currentEXP'] += xp
	else:
		currentPlayers[A['steam']]['gainedEXP'] += nDamage
		currentPlayers[A['steam']]['currentEXP'] += nDamage
	if nDamage >= V['health']:
		nPlayer = playerlib.getPlayer(V['id'])
		nPlayer.damage('#health', 32, A['id'], A['weapon'])
	es.setplayerprop(V['id'], 'CBasePlayer.m_iHealth', int(V['health'] - int(nDamage)))
	scanNewLevel(V['id'], V['steam'])
	scanNewLevel(A['id'], A['steam'])

def threadPlayerDeath(user, steamid):
	es.tell(user, '#multi', '#defaultTotal #lightgreenExperience #defaultgained this life ( #green%s#default )!'%(currentPlayers[steamid]['gainedEXP']))

def scanNewLevel(user,steamid):
	global currentPlayers, levelEXP
	cL = currentPlayers[steamid]['level']
	if cL >= int(attributes['maxLevel']):
		return
	if float(currentPlayers[steamid]['currentEXP']) >= levelEXP[cL + 1]:
		currentPlayers[steamid]['level'] += 1
		currentPlayers[steamid]['currentEXP'] -= levelEXP[cL + 1]
		currentPlayers[steamid]['unspentPoints'] += int(attributes['pointsPerLevel'])
		es.tell(user, '#multi', '#greenCONGRATULATIONS! #defaultYou have attained level #lightgreen%s'%(cL + 1))

def respecPlayer(user, steamid):
	global currentPlayers
	if currentPlayers[steamid]['level'] <= 0:
		es.tell(user, 'You have no need to respec, you are level 0')
		return
	currentPlayers[steamid]['power'] = 0
	currentPlayers[steamid]['precisions'] = 0
	currentPlayers[steamid]['toughness'] = 0
	currentPlayers[steamid]['vitality'] = 0
	currentPlayers[steamid]['unspentPoints'] = currentPlayers[steamid]['level'] * int(attributes['pointsPerLevel'])
	currentPlayers[steamid]['level'] -= int(attributes['respecCost'])
	es.tell(user, '#multi', '#defaultYour attributes have been reset.\nLevel:  %s\nUnspent Points:  %s'%(currentPlayers[steamid]['level'], currentPlayers[steamid]['unspentPoints']))

def menuCreate_Base(user, steamid):
	aUser = 'attributes_' + str(user)	
	try:
		popuplib.delete(aUser)
	except ValueError:
		pass
	
	tPopup = popuplib.create(aUser)
	tPopup.menuselect = menuSelect_Base
	tA = tPopup.addline
	
	tA('Level:  %s'%(currentPlayers[steamid]['level']))
	if currentPlayers[steamid]['level'] == attributes['maxLevel']:
		tA('Experience:  MAX  (%s)'%(currentPlayers[steamid]['currentEXP']))
	else:
		tA('Experience:  %s of %s'%(currentPlayers[steamid]['currentEXP'], levelEXP[currentPlayers[steamid]['level'] + 1]))
	if currentPlayers[steamid]['unspentPoints'] > 0:
		tA('===\nUnused Points:  %s\n==='%(currentPlayers[steamid]['unspentPoints']))
	tA(' ')
	tA('->1.Power:  %s'%(currentPlayers[steamid]['power']))
	tA('->2.Precision:  %s'%(currentPlayers[steamid]['precision']))
	tA('->3.Toughness:  %s'%(currentPlayers[steamid]['toughness']))
	tA('->4.Vitality:  %s'%(currentPlayers[steamid]['vitality']))
	tA(' ')
	if str(attributes['respec']).lower() == 'off':
		tA('Respec (Disabled)')
	else:
		tA('->8. Respec')
	tA('->9. Attribute Information')
	tA(' ')
	tA('->0. Exit')
	
	popuplib.send(aUser, user)

def menuCreate_Respec(user, steamid):
	aUser = 'respec_' + str(user)	
	try:
		popuplib.delete(aUser)
	except ValueError:
		pass
	
	tPopup = popuplib.create(aUser)
	tPopup.menuselect = menuSelect_Respec
	tA = tPopup.addline

	if attributes['respecCosts'] > 0:
		tA('Respecing your attributes will cost you %s level(s) \nand your experience will be reset to 0.'%(attributes['respecCosts']))
	else:
		tA('Respecing is FREE!')
	if attributes['respecLimit'] > 0:
		tA(' \nYou are currently limited to %s respec(s) every map.')
	else:
		tA(' \nYou can respec as much as you want.')
	tA(' ')
	tA('->1.Do you want to respec?')
	tA(' ')
	tA('->9. Back')
	tA('->10. Exit')
	
	popuplib.send(aUser, user)

def menuCreate_RespecConfirm(user, steamid):
	global confirmation
	confirmation.append(str(user))

	aUser = 'respecConfirm_' + str(user)	
	try:
		popuplib.delete(aUser)
	except ValueError:
		pass
	
	tPopup = popuplib.create(aUser)
	tPopup.menuselect = menuSelect_RespecConfirm
	tA = tPopup.addline
	
	tA('Respec confirmation:')
	tA(' ')
	tA(' ')
	tA('To CONFIRM respecialization type "yes" into chat now.')
	tA(' ')
	tA('Select Back or Exit to CANCEL respecialization.')
	tA(' ')
	tA('->9. Back')
	tA('->10. Exit')
	
	popuplib.send(aUser, user)

def menuCreate_Info(user):
	aUser = 'info_' + str(user)	
	try:
		popuplib.delete(aUser)
	except ValueError:
		pass
	
	tPopup = popuplib.create(aUser)
	tPopup.menuselect = menuSelect_Info
	tA = tPopup.addline

	tA('Power:\n     Increases regular weapon damage by, %s per point.'%(attributes['worthPower']))
	tA(' ')
	tA('Precision:\n     Increases your chance to critically hit by (%s) per point \n     (critical hits deal %s * precision bonus damage).'%(attributes['worthPrecision'], attributes['criticalBonus']))
	tA(' ')
	if attributes['minimumDamage'] > 0:
		tA('Toughness:\n     Reduces damage by (%s) per point.\n     You will still take (%s) damage.\n     This is to stop invulnerable people.'%(attributes['worthToughness'], attributes['minimumDamage']))
	else:
		tA('Toughness:\n     Reduces damage by (%s) per point.'%(attributes['worthToughness']))
	tA(' ')
	tA('Vitality:\n     Increases your health by (%s) per point.'%(attributes['worthVitality']))
	tA(' ')
	tA('->9. Back')
	tA('->10. Exit')
	
	popuplib.send(aUser, user)

def menuSelect_Base(user, choice, popupid):
	global currentPlayers, popups
	steamid = es.getplayersteamid(user)
	options = [1, 2, 3, 4]
	if currentPlayers[steamid]['unspentPoints'] <= 0:
		if choice in options:
			es.tell(user, 'You have no points to spend.')
			popups.remove(str(user))
			return
	if choice in options:
		currentPlayers[steamid]['unspentPoints'] -= 1
		popups.remove(str(user))
		if choice == 1:
			if currentPlayers[steamid]['power'] >= attributes['maxPointsPerStat']:
				es.tell(user, '#multi', '#lightgreenPower #lightgreenis maxxed out!')
				return
			currentPlayers[steamid]['power'] += 1
			es.tell(user, '#multi', '#lightgreenPower #defaulthas been increased to #green%s#default!'%(currentPlayers[steamid]['power']))
		elif choice == 2:
			if currentPlayers[steamid]['precision'] >= attributes['maxPointsPerStat']:
				es.tell(user, '#multi', '#lightgreenPrecision #lightgreenis maxxed out!')
			currentPlayers[steamid]['precision'] += 1
			es.tell(user, '#multi', '#lightgreenPrecision #defaulthas been increased to #green%s#default!'%(currentPlayers[steamid]['precision']))
		elif choice == 3:
			if currentPlayers[steamid]['toughness'] >= attributes['maxPointsPerStat']:
				es.tell(user, '#multi', '#lightgreenToughness #lightgreenis maxxed out!')
			currentPlayers[steamid]['toughness'] += 1
			es.tell(user, '#multi', '#lightgreenToughness #defaulthas been increased to #green%s#default!'%(currentPlayers[steamid]['toughness']))
		else:
			if currentPlayers[steamid]['vitality'] >= attributes['maxPointsPerStat']:
				es.tell(user, '#multi', '#lightgreenVitality #lightgreenis maxxed out!')
			currentPlayers[steamid]['vitality'] += 1
			es.tell(user, '#multi', '#lightgreenVitality #defaulthas been increased to #green%s#default!'%(currentPlayers[steamid]['vitality']))
		return
	elif choice == 8:
		menuCreate_Respec(user, steamid)
	elif choice == 9:
		menuCreate_Info(user)
	else:
		popups.remove(str(user))

def menuSelect_Respec(user, choice, popupid):
	if choice == 1:
		menuCreate_RespecConfirm(user, es.getplayersteamid(user))
	elif choice == 9:
		popuplib.send('attributes_%s'%(user), user)
	else:
		global popups
		popups.remove(str(user))

def menuSelect_RespecConfirm(user, choice, popupid):
	global confirmation
	confirmation.remove(str(user))
	if choice == 9:
		popuplib.send('respec_%s'%(user), user)
	else:
		global popups
		popups.remove(str(user))

def menuSelect_Info(user, choice, popupid):
	if choice == 9:
		popuplib.send('attributes_%s'%(user), user)
	else:
		global popups
		popups.remove(str(user))

def loadDB(steamid):
	if not steamid:
		return
	global currentPlayers
	currentPlayers[steamid] = {}
	file = dirs['db'] + str(steamid).replace(':','-') + '.db'
	if not os.path.isfile(file):
		es.server.printmsg(str(steamid) + ' not found, creating database.\n')
		currentPlayers[steamid] = {}
		currentPlayers[steamid]['level'] = 0
		currentPlayers[steamid]['currentEXP'] = 0
		currentPlayers[steamid]['gainedEXP'] = 0
		currentPlayers[steamid]['unspentPoints'] = 0
		currentPlayers[steamid]['respecs'] = 0
		currentPlayers[steamid]['power'] = 0
		currentPlayers[steamid]['precision'] = 0
		currentPlayers[steamid]['toughness'] = 0
		currentPlayers[steamid]['vitality'] = 0
		currentPlayers[steamid]['lastPlayed'] = {}
		currentPlayers[steamid]['lastPlayed']['year'] = now.year
		currentPlayers[steamid]['lastPlayed']['month'] = now.month
		currentPlayers[steamid]['lastPlayed']['day'] = now.day
		nFile = open(file, 'w')
		cPickle.dump(currentPlayers[steamid], nFile)
		nFile.close()
		return
	nFile = open(file, 'r')
	currentPlayers[steamid] = cPickle.load(nFile)
	nFile.close()

def deleteInactive(*args):
	for file in os.listdir(dirs['db']):
		file = dirs['db'] + str(file.strip("'"))
		nFile = open(file, 'r')
		tPlayer = cPickle.load(nFile)
		timeNow = datetime.date(now.year, now.month, now.day)
		timeOld = datetime.date(tPlayer['lastPlayed']['year'], tPlayer['lastPlayed']['month'], tPlayer['lastPlayed']['day'])
		timeCalc = str(timeNow - timeOld).split(' ')
		nFile.close()
		try:
			if int(timeCalc[0]) > attributes['timeDeleteInactive']:
				os.remove(file)
				es.server.printmsg(str(file).strip('.db') + ' DB has been deleted.\n')
		except:
			continue
	es.server.printmsg('Finished deleting inactive users.\n')

def buildLevelEXP():
	global levelEXP
	del levelEXP
	levelEXP = {}
	levelEXP[0] = 0
	i = 1
	nFile = open(dirs['cfg'] + '/Attributes Levels.txt', 'r')
	for line in nFile:
		levelEXP[i] = float(line)
		i += 1
	nFile.close()